:- module( pfd_demo, [
               pfd_version/2,               % Mj:Mn:Fx, date(Y,M,D)
               pfd_predicate/1,             % +Arg1
               pfd_demo/0,
               pfd_demo/1,                  % +Goals
               op( 400, fx, / )               % /Arg1  
    ] ).

/** <module> Probabilistic finite domains.

Implements probablilistic finite domains.

---++ Highlights

---++ Installation

To install
==
?- pack_install(pfd_meta).
==

to load
==
?- use_module(library(pfd_meta)).
==

---+++ module doc section 

---+++ Examples

==
?- pfd_demo(caesar).
==

---++ Pack info

@author   nicos angelopoulos
@version  0.0.1 2015/4/30
@see http://www.stoics.org.uk/~nicos/sware/pfd_meta

*/

/** pfd_version( -Version, -Date ).

Current version and release date for the library.

Currently: pfd_version( 0:0:1, date(2017,4,16) ).
*/
pfd_version( 0:0:1, date(2017,4,16) ).

:- ensure_loaded('../src/load_pfd').
