:- on_pl( swi(_), ensure_loaded('system/swi/std') ).

set_dbg( Flag ) :-
	( var(Flag) -> 
		bb_get( dbg, Flag )
		;
		( (Flag == on;Flag == off) ->
			bb_put( dbg, Flag )
			;
			write( 'use, set_dbg(on). or set_dbg(off).' ), nl
		)
	).

dbg( Write ) :- 
	( bb_get( dbg, on ) ->
		( is_list(Write) ->
			dbg_on_list( Write )
			;
			write( Write ), nl
		)
		;
		true
	).

dbg_on_list( [] ) :-  nl.
dbg_on_list( [H|T] ) :- 
	write( H ),
	dbg_on_list( T ).
